Limits = { }
local limit = 10		-- The max buildable objects you can have on a map, per player...
 
function printf(...) 
	io.write(string.format(unpack(arg))) 
end
function InputConsole(...)
	Console_Input(string.format(unpack(arg)))
end
 
 
function ScriptName()
	return "LUA_Player"
end
 
function ScriptParams()
	return ""
end
 
function Created(ID, obj)
	if Is_A_Star(obj) ~= false then
		Limits[Get_Player_ID(obj)] = 0;
	else
		Destroy_Object(obj)
	end
end
 
function Destroyed(ID, obj)
end
 
function Custom(ID, obj, message, param, sender)
	-- 1: Inrement build counter
	-- 2: Decrement build counter
	-- 3: Attempt build
	--		Note: Use a param to specify the object to build
	
	local pID = Get_Player_ID(obj)
	if message == 1 then
		Limits[pID] = Limits[pID] + 1
	elseif message == 2 then
		Limits[pID] = Limits[pID] - 1
	elseif message == 3 then
		if Limits[pID] == limit then
			InputConsole("ppage %d Error: You cannot build anything else.", pID)
		else
			local obj = BuildableObjects(param, pID)
			if obj ~= nil then
				Attach_Script_Once(obj, "LUA_Build_Limit", pID)
			else
				InputConsole("msg Error building object. Please check \"BuildableObjects\" function in LuaPlugins\\LUA_Player.lua")
			end
		end
	end
end


-- @author Zack
-- @summary Validates passed parameters whether you can build the object or not.
-- @param ID The paramater sent through the custom event
-- @param pID The player ID of the current player
-- @returns Returns a GameObject of the object that was created. (Needs to be validated for nil)

-- @notes You may edit this function as you see fit

function BuildableObjects(ID, pID)
	if Get_GameObj(pID) == nil then
		return
	end

	local pos = Get_Position(Get_GameObj(pID))
	if ID == 1 then
		pos:AssignX(pos:GetX()+2)
		return Create_Object("pct_gdi_zone", pos)
	elseif ID == 2 then
		pos:AssignX(pos:GetX()+2)
		return Create_Object("pct_nod_zone", pos)
	end
end

-- @author Zack
-- @summary Checks whether a GameObject is a player or not
-- @param obj The GameObject to validate
-- @returns Returns true if the GameObject passed is a player, else returns false.
function Is_A_Star(obj)
	if Get_Player_ID(obj) then
		return true
	else
		return false
	end
end